unit UnidadMenuPrincipal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ActiveX, ComObj, shellapi, ComCtrls;

type
  TformMenuPrincipal = class(TForm)
    LWEB: TLabel;
    dlAbrir: TOpenDialog;
    PageControl1: TPageControl;
    tabPuerto: TTabSheet;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    txtNombre: TEdit;
    txtNumero: TEdit;
    bAbrirPuerto: TButton;
    GroupBox3: TGroupBox;
    opTCP: TRadioButton;
    opUDP: TRadioButton;
    GroupBox5: TGroupBox;
    opPuertoAmbitoLocal: TRadioButton;
    opPuertoAmbitoInternet: TRadioButton;
    GroupBox4: TGroupBox;
    Label5: TLabel;
    bActivarRegla: TButton;
    txtActivarPuerto: TEdit;
    GroupBox7: TGroupBox;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    tabAplicacion: TTabSheet;
    GroupBox2: TGroupBox;
    Label3: TLabel;
    Label4: TLabel;
    txtAplicacionNombre: TEdit;
    txtAplicacionRuta: TEdit;
    bAbrirAplicacion: TButton;
    bSel: TButton;
    GroupBox6: TGroupBox;
    opAplicacionAmbitoLocal: TRadioButton;
    opAplicacionAmbitoInternet: TRadioButton;
    opActivar: TCheckBox;
    tabEstado: TTabSheet;
    GroupBox8: TGroupBox;
    btEstadoActivar: TButton;
    bEstadoDesactivar: TButton;
    Label6: TLabel;
    procedure bAbrirPuertoClick(Sender: TObject);
    procedure LWEBClick(Sender: TObject);
    procedure bSelClick(Sender: TObject);
    procedure bAbrirAplicacionClick(Sender: TObject);
    procedure bActivarReglaClick(Sender: TObject);
    procedure btEstadoActivarClick(Sender: TObject);
    procedure bEstadoDesactivarClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formMenuPrincipal: TformMenuPrincipal;
  const
   NET_FW_PROFILE_DOMAIN = 0;
   NET_FW_PROFILE_STANDARD = 1;
   NET_FW_IP_VERSION_ANY = 2;
   NET_FW_IP_PROTOCOL_UDP = 17;
   NET_FW_IP_PROTOCOL_TCP = 6;
   NET_FW_SCOPE_ALL = 0;
   NET_FW_SCOPE_LOCAL_SUBNET = 1;


implementation

{$R *.dfm}

procedure abrirPuertoFirewall (nombreEntrada : string; numeroPuerto : Cardinal;
    protocoloTCP : boolean; ambitoLocal : boolean; activar : Boolean);
var
  fwMgr, objPuerto : OleVariant;
  perfil : OleVariant;
begin
  fwMgr := CreateOLEObject('HNetCfg.FwMgr');
  perfil := fwMgr.LocalPolicy.CurrentProfile;
  objPuerto := CreateOLEObject('HNetCfg.FWOpenPort');
  objPuerto.Name := nombreEntrada;
  if protocoloTCP then
    objPuerto.Protocol := NET_FW_IP_PROTOCOL_TCP
  else
    objPuerto.Protocol := NET_FW_IP_PROTOCOL_UDP;
  objPuerto.Port := numeroPuerto;
  if ambitoLocal then
    objPuerto.Scope := NET_FW_SCOPE_LOCAL_SUBNET
  else
    objPuerto.Scope := NET_FW_SCOPE_ALL;
  objPuerto.Enabled := true;
  perfil.GloballyOpenPorts.Add(objPuerto);
end;

procedure activarReglaFirewall (numeroPuerto : Cardinal;
    protocoloTCP : boolean; activar : Boolean);
var
  fwMgr, objPuerto : OleVariant;
  perfil : OleVariant;
begin
  fwMgr := CreateOLEObject('HNetCfg.FwMgr');
  perfil := fwMgr.LocalPolicy.CurrentProfile;
  objPuerto := CreateOLEObject('HNetCfg.FWOpenPort');
  if protocoloTCP then
    objPuerto.Protocol := NET_FW_IP_PROTOCOL_TCP
  else
    objPuerto.Protocol := NET_FW_IP_PROTOCOL_UDP;
  objPuerto.Port := numeroPuerto;
  objPuerto.Enabled := activar;
  perfil.GloballyOpenPorts.Add(objPuerto);
end;
 
procedure abrirAplicacionFirewall (nombreEntrada : string;
    rutaAplicacion : string; ambitoLocal : boolean; activar : Boolean);
var
  fwMgr, objAplicacion : OleVariant;
  perfil : OleVariant;
begin
  fwMgr := CreateOLEObject('HNetCfg.FwMgr');
  perfil := fwMgr.LocalPolicy.CurrentProfile;
  objAplicacion := CreateOLEObject('HNetCfg.FwAuthorizedApplication');
  objAplicacion.ProcessImageFileName := rutaAplicacion;
  objAplicacion.Name := nombreEntrada;
  if ambitoLocal then
    objAplicacion.Scope := NET_FW_SCOPE_LOCAL_SUBNET
  else
    objAplicacion.Scope := NET_FW_SCOPE_ALL;
  objAplicacion.IpVersion := NET_FW_IP_VERSION_ANY;
  objAplicacion.Enabled := activar;
  perfil.AuthorizedApplications.Add(objAplicacion);
end;

procedure activarDesactivarFirewall (activar : boolean);
var
  fwMgr : OleVariant;
  perfil : OleVariant;
begin
  fwMgr := CreateOLEObject('HNetCfg.FwMgr');
  perfil := fwMgr.LocalPolicy.CurrentProfile;
  perfil.FirewallEnabled := activar;
end;

procedure TformMenuPrincipal.bAbrirPuertoClick(Sender: TObject);
begin
  abrirPuertoFirewall (txtNombre.Text, strtoint(txtNumero.Text),
      opTCP.Checked, opPuertoAmbitoLocal.Checked, true);
  MessageDlg('Regla aadida al cortafuegos de Windows.',
      mtInformation, [mbok], 0);
end;

procedure TformMenuPrincipal.LWEBClick(Sender: TObject);
begin
  ShellExecute(Handle, Nil, PChar('www.ajpdsoft.com'),
      Nil, Nil, SW_SHOWNORMAL);
end;

procedure TformMenuPrincipal.bSelClick(Sender: TObject);
begin
  if dlAbrir.Execute then
    txtAplicacionRuta.Text := dlAbrir.FileName;
end;

procedure TformMenuPrincipal.bAbrirAplicacionClick(Sender: TObject);
begin
  abrirAplicacionFirewall(txtAplicacionNombre.Text,
      txtAplicacionRuta.Text, opAplicacionAmbitoLocal.Checked, true);
  MessageDlg('Aplicacin aadida al cortafuegos de Windows.',
      mtInformation, [mbok], 0);
end;

procedure TformMenuPrincipal.bActivarReglaClick(Sender: TObject);
begin
  activarReglaFirewall (strtoint(txtActivarPuerto.Text),
      opTCP.Checked, opActivar.Checked);
  MessageDlg('Regla aadida al cortafuegos de Windows.',
      mtInformation, [mbok], 0);
end;

procedure TformMenuPrincipal.btEstadoActivarClick(Sender: TObject);
begin
  activarDesactivarFirewall(True);
  MessageDlg('Cortafuegos de Windows activado.',
      mtInformation, [mbok], 0);
end;

procedure TformMenuPrincipal.bEstadoDesactivarClick(Sender: TObject);
begin
  activarDesactivarFirewall(false);
  MessageDlg('Cortafuegos de Windows desactivado.',
      mtInformation, [mbok], 0);        
end;

end.
